const SmartySDK = require("smartystreets-javascript-sdk");
const SmartyCore = SmartySDK.core;
const Lookup = SmartySDK.usEnrichment.Lookup;

// for Server-to-server requests, use this code:
// let authId = process.env.SMARTY_AUTH_ID;
// let authToken = process.env.SMARTY_AUTH_TOKEN;
// const credentials = new SmartyCore.StaticCredentials(authId, authToken);

// for client-side requests (browser/mobile), use this code:
let key = process.env.SMARTY_EMBEDDED_KEY;
const credentials = new SmartyCore.SharedCredentials(key);

// The appropriate license values to be used for your subscriptions
// can be found on the Subscription page of the account dashboard.
// https://www.smarty.com/docs/cloud/licensing
let clientBuilder = new SmartyCore.ClientBuilder(credentials).withLicenses(["us-property-data-principal-cloud"]);
let client = clientBuilder.buildUsEnrichmentClient();
console.log(client);

// Documentation for input fields can be found at:
// https://www.smarty.com/docs/us-street-api#input-fields

let lookup = new Lookup("7");

handleResponse(lookup).then();

function handleSuccess(response) {
    response.lookups.map(lookup => console.log(lookup.result));
}

function handleError(response) {
    console.log(response);
}

async function handleResponse(lookup) {
    try {
        const result = await client.sendPrincipal(lookup);
        handleSuccess(result);
    } catch(err) {
        handleError(err);
    }
}